function checkPasswordStrength( $pass1,
                                $pass2,
                                $strengthResult,
                                $submitButton,
                                blacklistArray ) {
	var pass1 = $pass1.val();
	var pass2 = $pass2.val();

	$submitButton.attr( 'disabled', 'disabled' );
	$strengthResult.removeClass( 'short bad good strong mismatch' );
	
	// Extend blacklist array with those from the inputs & site data
	blacklistArray = blacklistArray.concat( wp.passwordStrength.userInputBlacklist() )
	
	// Check password strength
	var strength = wp.passwordStrength.meter( pass1, blacklistArray, pass2 );

	// Add results
	switch ( strength ) {
		case 2:
			$strengthResult.addClass( 'bad' ).html( pwsL10n.bad );
			break;
	
		case 3:
			$strengthResult.addClass( 'good' ).html( pwsL10n.good );
			break;
	
		case 4:
			$strengthResult.addClass( 'strong' ).html( pwsL10n.strong );
			break;
	
		case 5:
			$strengthResult.addClass( 'mismatch' ).html( pwsL10n.mismatch );
			break;
	
		default:
			$strengthResult.addClass( 'short' ).html( pwsL10n.short );
			break;
	}
	
	// The meter function returns a result even if pass2 is empty,
	// enable only the submit button if the password is strong
	if ( 4 === strength ) {
		$submitButton.removeAttr( 'disabled' );
	}
	
	return strength;
}
 
jQuery( document ).ready( function( $ ) {
    $( 'body' ).on( 'keyup', '#ign_wsp_form input[type=password]:eq(0), #ign_wsp_form input[type=password]:eq(1)',
		function( event ) {
			pass_strength_div = $( this ).parent().find( '.pass-strength-result' );
			checkPasswordStrength(
				$('input[type=password]'),
				$('input[type=password]:eq(1)'),
				pass_strength_div,
				$('input[type=submit]'),
				[] // Blacklisted words
			);
		}
	);
});
