<?php 
/**
 * Copyright (c) 2019 - IgniteWoo.com - All Rights Reserved 
 
 * This is a basic cache class - currently not implemented, not necessary yet.
 */

if ( ! defined( 'ABSPATH' ) ) exit;


class IGN_WSP_Cache {
	
	public function __construct() {
return;
		add_action( 'woocommerce_settings_saved', array( $this , 'clear_entire_query_cache' ), 10 );
		add_action( 'created_product_cat', array( $this , 'clear_entire_query_cache' ), 10 , 2 ); 
		add_action( 'edit_term', array( $this , 'clear_entire_query_cache' ), 10 , 3 );
		add_action( 'delete_product_cat', array( $this , 'clear_entire_query_cache' ), 10, 4 ); 
		add_action( 'save_post', array( $this , 'clear_query_cache_for_products' ), 10, 1 );
	}
	
	public static function get_cache_key( $data ) { 
		return '_ign_wsp_' . $data . '_cache';
	}
	
	public static function  clear_entire_query_cache() { 
		global $wp_roles; 

		if ( empty( $wp_roles ) || empty( $wp_roles->roles ) ) {
			return;
		}
		
		foreach( $wp_roles->roles as $role ) {
			if ( 'ignite_level_' == substr( $role, 0, 13 ) ) {
				delete_transient( self::get_cache_key( $role ) );
				
			}
		}
	}
	
	public static function  set_query_cache( $key, $data, $duration ) { 
		return set_transient( $key, $data, $duration );
	}
	
	public static function get_query_cache( $key ) { 
		return get_transient( $key );
	}
	
	public static function clear_query_cache_for_products( $post_id, $post ) { 
	
		if ( defined( 'DOING_AUTOSAVE' ) && DOING_AUTOSAVE ) {
			return $post_id;
		}

		// Don't save revisions and autosaves.
		if ( wp_is_post_revision( $post_id ) || wp_is_post_autosave( $post_id ) || 'product' !== $post->post_type || !current_user_can( 'edit_post', $post_id ) ) {
			return $post_id;
		}
		
		self::clear_entire_query_cache();
	}
}

new IGN_WSP_Cache();
