<?php 
// Handles Aelia, WC Currency Switcher, and WPML/WCML: 

if ( ! defined( 'ABSPATH' ) ) exit; // Exit if accessed directly

if ( !class_exists('IGN_WSP_CURRENCY_HELPER') ) {

	/*
	 * WooCommerce Currency Switcher Integration helper class.
	 */
	class IGN_WSP_CURRENCY_HELPER {

		public static function convert( $amount, $product ) { 

			$amount = self::wccs_convert( $amount );
			
			// WPML currency switcher integration not finished
			//$amount = self::wpml_convert( $amount );
			
			$amount = self::aelia_convert( $amount, $product );
			
			$amount = self::yay_convert( $amount, $product );
			
			return $amount; 
		}
	
		public static function yay_convert( $amount, $_product ) {

			if ( ! class_exists( 'Yay_Currency\Helpers\YayCurrencyHelper' ) ) {
				return $amount;
			}

			$apply_currency = Yay_Currency\Helpers\YayCurrencyHelper::detect_current_currency(); // get current currency on site
			// $price = 10; // price from default currency , ex: CAD
			$rate = Yay_Currency\Helpers\YayCurrencyHelper::get_rate_fee( $apply_currency /*$currency*/ ); // get rate current currency, default currency rate is 1
			$converted_price = Yay_Currency\Helpers\YayCurrencyHelper::calculate_price_by_currency( $amount, false, $apply_currency ); // convert price from default
			//currency to current currency, ex: from CAD to USD
			return $converted_price;
		}
	
		public static function aelia_convert( $amount, $_product ) {
			return $amount; 
			// Do not do this, latest Aelia already handles conversion: 
			/*
			$active_currency = get_woocommerce_currency();
			$base_currency   = IGN_ACS_Integration_Helper::get_product_base_currency( $_product->get_id() );
			$amount = IGN_ACS_Integration_Helper::convert( $amount, $active_currency, $base_currency );
			return $amount; 
			*/
		}
		
		public static function wpml_convert( $amount ) { 
			global $woocommerce_wpml;
			
			if ( empty( $woocommerce_wpml ) || empty( $woocommerce_wpml->multi_currency ) ) {
				return $amount; 
			}
			
			if ( $woocommerce_wpml->multi_currency->get_client_currency() != get_option('woocommerce_currency') ) { 
				$amount = apply_filters( 'wcml_formatted_price' , $amount );
			}
			return $amount; 
		}
		
		public static function wccs_convert( $amount ) {
			global $WOOCS;

			if ( !class_exists( 'WOOCS' ) ) {
				return $amount; 
			}
			
			$currency = $WOOCS->current_currency;
			
			if ( $currency == $WOOCS->default_currency ) {
				return $amount;
			}
		
			$currencies = $WOOCS->get_currencies();
			
			$rate = $currencies[ $currency ]['rate'];
			
			if ( empty( $amount ) || empty( $rate ) ) { 
				return $amount; 
			}
			
			//$amount = round( $amount / $rate, 2 );
			
			return $amount;
		}
	}
}
