<?php

/*
 * Copyright (c) 2016 - IgniteWoo.com - ALL RIGHTS RESERVED
 */

//@ini_set( 'display_errors' , true );
//@ini_set( 'error_reporting', E_ALL );


class IGN_Wholesale_Pro_Quick_Orders {

	public static $plugin_dir;
	
	public static $settings = array();
	
	public static $version_ok = true;
	
	public static $inject_scripts = false; 
	
	public static $form_id;
	
	public static $search_string;
	
	public static $per_page_options;
	
	public static $sort_order;
	public static $sort_orderby;

	public function __construct() { 

		self::$plugin_dir = dirname( __FILE__ );
				
		add_action( 'init', __CLASS__ . '::version_check', 11 );
		
		add_action( 'init', __CLASS__ . '::register_post_type', 99 );
		add_action( 'add_meta_boxes', __CLASS__ . '::add_meta_boxes', 15 );
		add_filter( 'save_post', __CLASS__ . '::save_post', 5 );
		add_filter( 'woocommerce_screen_ids', __CLASS__ . '::screen_ids' );
		
		add_action( 'woocommerce_integrations', __CLASS__ . '::settings_init' );

		add_filter( 'woocommerce_ajax_variation_threshold', __CLASS__ . '::max_variations', 999, 1 );

		// DT ajax hook
		add_action( 'wp_ajax_ign_qof_load_products', __CLASS__ . '::get_products' );
		add_action( 'wp_ajax_nopriv_ign_qof_load_products', __CLASS__ . '::get_products' );
		
		add_action( 'wp_ajax_ign_add_to_cart', __CLASS__ . '::add_to_cart' );
		add_action( 'wp_ajax_nopriv_ign_add_to_cart', __CLASS__ . '::add_to_cart' );
		
		add_action( 'wp_ajax_ign_add_to_cart_variable', __CLASS__ . '::add_to_cart_variable' );
		add_action( 'wp_ajax_nopriv_ign_add_to_cart_variable', __CLASS__ . '::add_to_cart_variable' );
				
		add_action( 'wp_ajax_ign_multi_add_to_cart', __CLASS__ . '::multi_add_to_cart' );
		add_action( 'wp_ajax_nopriv_ign_multi_add_to_cart', __CLASS__ . '::multi_add_to_cart' );

		// Intercepts a non-Ajax form post, used when Ajax Add to Cart is disable via settings
		add_action( 'wp_loaded', __CLASS__ . '::check_non_ajax_add_to_cart', 15 );
		
		// For backend settings product search
		add_action( 'wp_ajax_ign_search_products', __CLASS__ . '::json_search_products' );
		add_action( 'wp_ajax_nopriv_ign_search_products', __CLASS__ . '::json_search_products' );

		add_shortcode( 'wsp_quick_order_form', __CLASS__ . '::shortcode' );
		
		add_filter( 'wp_footer', __CLASS__ . '::wp_footer', 9 );
		
	}

	public static function version_check() { 
		if ( version_compare( WOOCOMMERCE_VERSION, '2.2', '<' ) ) {
			self::$version_ok = false;
		}
	}

	public static function settings_init( $integrations ) {
		require_once( dirname( __FILE__ ) . '/class-wc-wholesale-pro-quick-order-settings.php' );
		return $integrations;
	}

	public static function wp_footer() { 
	
		if ( !self::$inject_scripts ) 
			return;

		$js_dir = str_replace( array( 'http:', 'https:' ), '', trailingslashit( ( plugins_url( '/../assets/js/', __FILE__ ) ) ) );
		$css_dir = str_replace( array( 'http:', 'https:' ), '', trailingslashit( ( plugins_url( '/../assets/css/', __FILE__ ) ) ) );

		$img_dir = str_replace( array( 'http:', 'https:' ), '', trailingslashit( ( plugins_url( '/../assets/images/', __FILE__ ) ) ) );
		
		//wp_dequeue_script( 'wc-add-to-cart' );
		wp_dequeue_script( 'wc-add-to-cart-variation' );
				
		$disable_ajax_atc = false; 
		
		if ( empty( self::$settings['disable_ajax_atc'] ) || 'yes' == self::$settings['disable_ajax_atc'] ) { 
			$disable_ajax_atc = true;
		}
		
		wp_register_script( 'ign-add-to-cart', $js_dir . 'add-to-cart.js', array( 'jquery' ), WOOCOMMERCE_VERSION, true );		
		wp_enqueue_script( 'ign-add-to-cart' );
		wp_localize_script( 'ign-add-to-cart', 'ign_add_to_cart_params', apply_filters( 'wc_add_to_cart_params', array(
			'ajax_url'                => WC()->ajax_url(),
			'wc_ajax_url'                => WC()->ajax_url(),
			'ajax_loader_url'         => $img_dir . '/ajax-loader@2x.gif',
			'i18n_view_cart'          => '', //esc_attr__( 'View Cart', 'ignitewoo_wholesale_pro' ),
			'cart_url'                => get_permalink( wc_get_page_id( 'cart' ) ),
			'is_cart'                 => is_cart(),
			'cart_redirect_after_add' => get_option( 'woocommerce_cart_redirect_after_add' ),
			'add_to_cart_error'	  => __( 'Error adding item to cart', 'ignitewoo_wholesale_pro'),
		) ) );

		wp_register_script( 'ign-add-to-cart-variation', $js_dir . 'add-to-cart-variations.js', array( 'jquery' ), WOOCOMMERCE_VERSION, true );	
		wp_enqueue_script( 'ign-add-to-cart-variation' );
		wp_localize_script( 'ign-add-to-cart-variation', 'ign_add_to_cart_variation_params', apply_filters( 'wc_add_to_cart_variation_params', array(
			'i18n_no_matching_variations_text' => esc_attr__( 'Sorry, no products matched your selection. Please choose a different combination.', 'ignitewoo_wholesale_pro' ),
			'i18n_unavailable_text'            => esc_attr__( 'Sorry, this product is unavailable. Please choose a different combination.', 'ignitewoo_wholesale_pro' ),
		) ) );
		
		wp_enqueue_script( 'ign-add-to-cart-alert', $js_dir . 'jquery-confirm.min.js', array( 'jquery' ), time(), true );
		wp_enqueue_style( 'ign-add-to-cart-alert', $css_dir . 'jquery-confirm.min.css', time(), true );
		
		wp_enqueue_script( 'prettyPhoto', WC()->plugin_url() . '/assets/js/prettyPhoto/jquery.prettyPhoto.min.js', array( 'jquery' ), time(), true );
		wp_enqueue_style( 'prettyPhoto', WC()->plugin_url() . '/assets/css/prettyPhoto.css', time(), true );
		
		wp_enqueue_script( 'jquery-blockui' );
				
		wp_enqueue_style( 'ign_datatables_css', $css_dir . 'jquery.dataTables.min.css', time(), true );
		wp_enqueue_style( 'ign_datatables_responsive_css', $css_dir . 'responsive.dataTables.min.css', time(), true );
		wp_enqueue_script( 'ign_datatables', $js_dir . '/datatables.min.js' );
		
		wp_register_script( 'ign_quick_orders', $js_dir . '/quick-orders.js' );
		wp_localize_script( 'ign_quick_orders', 'ign_qof_dt_params', array(
			'disable_ajax_atc'	=> $disable_ajax_atc,
		) );
		wp_enqueue_script( 'ign_quick_orders', $js_dir . '/quick-orders.js' );
		
		//wp_enqueue_script( 'ign_quick_orders', $js_dir . '/jquery.serialize-object.js.js' );
		
		wp_enqueue_style( 'ign-qof-css', $css_dir . 'quick-order-form.css', time(), true );
				
		$params = array( 
			"ajax_url" => admin_url( 'admin-ajax.php' ),
			"ajax_nonce" => wp_create_nonce( 'quick_orders' ),
			"wrapper_class" => "wc-product-table-wrapper storefront",
			"multi_cart_button_class" => "button btn",
			"default_per_page" => !empty( self::$settings['per_page'] ) ? self::$settings['per_page'] : 10,
			"loading" => __("Processing...", 'ignitewoo_wholesale_pro' ),
			'language'                => array(
				'info'                 => __( 'Showing _START_ to _END_ of _TOTAL_ products', 'ignitewoo_wholesale_pro' ),
				'infoEmpty'            => __( 'Showing 0 products', 'ignitewoo_wholesale_pro' ),
				'infoFiltered'         => __( '(_MAX_ products in total)', 'ignitewoo_wholesale_pro' ),
				'lengthMenu'           => __( 'Show _MENU_ products', 'ignitewoo_wholesale_pro' ),
				'emptyTable'           => __( 'No matching products found.', 'ignitewoo_wholesale_pro' ),
				'zeroRecords'          => __( 'No matching products found.', 'ignitewoo_wholesale_pro' ),
				'search'               => __( 'Search:', 'ignitewoo_wholesale_pro' ),
				"paginate" => array( 
					"last" => "&raquo;",
					"first" => "&laquo;",
					"next" => "&rsaquo;",
					"previous" => "&lsaquo;",
				),
			)
		);
		
		$per_page_options = array(
			10 => 10,
			25 => 25,
			50 => 50,
			100 => 100,
			9999999 => __( '"All"', 'ignitewoo_wholesale_pro' ),
		);
		
		// If the setting has a value not in the list then add it
		if ( !empty( self::$settings['per_page'] ) && !in_array( absint( self::$settings['per_page'] ), $per_page_options ) ) {
			$per_page_options[ absint( self::$settings['per_page'] ) ] = absint( self::$settings['per_page'] );
		}

		// Sort low to high by key
		ksort( $per_page_options );
		
		$params['per_page_options'] = array( 
			array_keys( $per_page_options ),
			array_values( $per_page_options )
		);

		// Disable paging? If so do not show the info bar (showing X of Y items...), or the page length or the pager controls
		if ( isset( self::$settings['disable_paging'] ) && 'yes' == self::$settings['disable_paging'] )
			$params['dom'] = '<"top"<"clear">>rt<"bottom"<"clear">>';
		else 
			$params['dom'] = '<"top"lp<"clear">>rt<"bottom"ip<"clear">>';

		$field_defs = array();
		$cols = array();
		
		$field_defs[] = array(
			'className' => 'control',
			'orderable' => false,
			'targets' => [0]
		);
            
		foreach( self::get_fields() as $k => $field ) { 
			if ( !empty( $field['orderable'] ) && true === $field['orderable'] )
				$orderable = true;
			else 
				$orderable = false; 
				
			$field_defs[] = array(
				'className' => $field['className'],
				'targets' => array( $k + 1 ),
				'orderable' => $orderable,
				'title' => $field['name'],
				'responsivePriority' => isset( $field['priority'] ) ? $field['priority'] : 1,
			);
		}

		$params['columndefs'] = $field_defs;

		wp_localize_script( 'ign_quick_orders', 'product_table_params', $params );
	}
	
	// WC limits variation data to max of 30 JSON attrs, not good for quick order form page where 
	// we may have multiple variation on a page
	public static function max_variations() { 
		return 800;
	}
	
	public static function get_settings( $id ) { 
		$quick_order_settings = get_post_meta( $id, 'quick_order_settings', true );
		$quick_order_settings['form_id'] = $id;
		self::$settings = $quick_order_settings;
		return;
	}
	
	public static function shortcode( $attrs = array(), $content = '' ) { 
		global $products, $user_ID, $restricted_cats, $quick_order_settings, $qof_id, $ign_wholesale_pro_suite;
		
		if ( is_admin() ) 
			return $content; 
			
		if ( !empty( $ign_wholesale_pro_suite->settings['login_required_for_prices'] ) && 'yes' == $ign_wholesale_pro_suite->settings['login_required_for_prices'] && !is_user_logged_in() ) {
			return $ign_wholesale_pro_suite->replace_price_html( '' );
		}
		
		$attrs = shortcode_atts( array(
			'id' => '',
			), 
			$attrs, 
			'quick_order_form' 
		);
		
		if ( empty( $attrs['id'] ) ) {
			return sprintf ( __( 'You must provide an ID parameter in the shortcode. Please read <a href="%s" target="_blank">the documentation</a>', 'ignitewoo_wholesale_pro' ), '//ignitewoo.com/ignitewoo-software-documentation/' );
		}
	
		self::get_settings( $attrs['id'] );
		
		self::$form_id = $attrs['id'];

		// Support for Restricted Category Access
		if ( function_exists( 'ign_get_user_restricted_categories' ) )
			$restricted_cats = ign_get_user_restricted_categories();
		else 
			$restricted_cats = null;
			
		if ( !self::$version_ok )
			return __( 'WooCommerce Quick Orders requires WooCommerce 2.2 or newer to operate', 'ignitewoo_wholesale_pro' );
			
		if ( empty( self::$settings ) )
			return __( 'Please configure the settings and save them at least once before using this plugin', 'ignitewoo_wholesale_pro' );

		$qof_id = $attrs['id'];
		
		$role_allowed = false; 
	
		if ( !empty( self::$settings['roles'] ) ) { 
			
			foreach( self::$settings['roles'] as $role ) { 
				if ( current_user_can( $role ) ) 
					$role_allowed = true; 
			}
			
		} else { 
			$role_allowed = true;
		}
		
		if ( !is_user_logged_in() && !empty( self::$settings['roles'] ) && in_array( 'guest', self::$settings['roles' ] ) )
			$role_allowed = true;

		if ( !$role_allowed )
			return wpautop( self::$settings['access_denied_message'] );
		
		self::$inject_scripts = true; 

		if ( class_exists( 'IgniteWoo_Restrict_Product_Categories' ) || class_exists( 'IgniteWoo_Tiered_Pricing_Filter' ) ) {
			$product_restrictions = apply_filters( 'loop_shop_post_in', array() );	
		} else { 
			$product_restrictions = null;
		}
		
		ob_start();
		self::get_template( 'quick-order-form-3.php' );
		return ob_get_clean();
	}

	public static function get_fields() { 

		$fields = array();
				
		// Default fields to show are Image, Name, Price, Buy - other fields can be enabled via settings
		
		if ( isset( self::$settings['show_image'] ) && 'yes' == self::$settings['show_image'] ) { 
			$fields[] = array( 'name' => __( '', 'ignitewoo_wholesale_pro' ), 'data' => false, 'getter' => 'get_image_id', 'className' => 'product-table-image' );
		}
		
		$fields[] = array( 'name' => __( 'Name', 'ignitewoo_wholesale_pro' ), 'data' => 'post_title', 'getter' => 'get_the_title', 'className' => 'title', 'orderable' => true );
		
		if ( isset( self::$settings['show_sku'] ) && 'yes' == self::$settings['show_sku'] ) { 
			$fields[] = array( 'name' => __( 'SKU', 'ignitewoo_wholesale_pro' ), 'data' => '_sku', 'getter' => 'get_sku', 'className' => 'sku', 'orderable' => true );
		}
		
		if ( isset( self::$settings['show_price'] ) && 'yes' == self::$settings['show_price'] ) { 
			$fields[] = array( 'name' => __( 'Price', 'ignitewoo_wholesale_pro' ), 'data' => '_price', 'getter' => 'get_price_html', 'className' => 'price', 'orderable' => true );
		}
		
		if ( isset( self::$settings['show_desc'] ) && 'yes' == self::$settings['show_desc'] ) { 
			$fields[] = array( 'name' => __( 'Description', 'ignitewoo_wholesale_pro' ), 'data' => false, 'getter' => 'get_description', 'className' => 'description', 'priority' => 99 );
		}
		
		$fields[] = array( 'name' => __( 'Buy', 'ignitewoo_wholesale_pro' ), 'data' => false, 'getter' => 'get_add_to_cart', 'className' => 'buy' );
		
		if ( isset( self::$settings['multi_add'] ) && 'yes' == self::$settings['multi_add'] )
			$fields[] = array( 'name' => '', 'data' => 'checkbox', 'data' => false, 'getter' => 'get_checkbox', 'className' => 'product_checkbox' );
		
		return $fields;
	}
	
	public static function get_template( $template = '', $load = true ) { 
		
		if ( empty( $template ) )
			return;
		
		if ( file_exists( get_stylesheet_directory() . '/quick-orders/' . $template ) )
			$file = get_stylesheet_directory() . '/quick-orders/' . $template;
		else 
			$file = self::$plugin_dir . '/../quick-orders/' . $template;

		if ( $load )
			load_template( $file, false );
		else
			return $file;
			
	}
	
	public static function get_products() {
		global $wpdb, $max_number_pages, $wp_version, $post, $ign_wholesale_pro_suite, $current_user;

		self::$search_string = false; 
		$search_cat = false; 
									
		$form_id = $_POST['table_id'];
		
		$form_id = absint( str_replace( 'ign_qof_table_', '', $form_id ) );

		self::get_settings( $form_id );

		if ( !empty( $_POST['search']['value'] ) ) {
		
			$values = json_decode( stripslashes( $_POST['search']['value'] ) );

			if ( !empty( $values ) ) { 
				foreach( $values as $k => $v ) { 
					if ( 'quick_order_search' == $v->name )
						self::$search_string = $v->value;
						
					if ( 'cat' == $v->name )
						$search_cat = $v->value;
				}
			}
		}

		if ( !empty( $search_cat ) ) 
			self::$settings['include_categories'][] = $search_cat;

		if ( class_exists( 'IgniteWoo_Restrict_Product_Categories' ) || class_exists( 'IgniteWoo_Tiered_Pricing_Filter' ) ) {
			$product_restrictions = apply_filters( 'loop_shop_post_in', array() );	
		} else { 
			$product_restrictions = array();
		}

		$current_page = absint( $_POST['page'] ) + 1;

		// Default settings 
		$orderby = self::$settings['sort_by'];
		$order = self::$settings['sort_order'];
		$per_page = !empty( self::$settings['per_page'] ) ? self::$settings['per_page'] : -1;

		/*
		if ( !empty( $_POST['order'] ) && 0 !== $_POST['order'][0]['column'] ) { 
			$fields = self::get_fields();
			$orderby = $fields[ $_POST['order'][0]['column'] -1 ]['data'];
			$order = $_POST['order'][0]['dir'];
		}
		*/
		if ( !empty( $_POST['length'] ) )
			$per_page = absint( $_POST['length'] );

		// Do not use the session orderby data from DT unless the column has a data value, 
		// this prevents a default sort on the hidden checkbox or image column (if present )
		if ( !empty( $_POST['order'] ) && 0 !== $_POST['order'][0]['column'] ) { 

			$order = $_POST['order'][0]['dir'];
						
			$orderby_id = $_POST['order'][0]['column'] - 1;
			
			if ( $orderby_id > 0 ) { 
				$fields = self::get_fields();
				$the_field = $fields[ $orderby_id ]['data'];
			}
			
			if ( !empty( $the_field ) ) { 
				$orderby = $the_field;
			}
		}

		$sku_query = array(
			'key'    => '_sku',
			'value'    => '%*%*%*%*', // dummy val so that all SKUs are valid and considered even if SKU is empty
			//'type' => 'CHAR',
			'compare' => '!=',
		);
		
		$price_query = array(
			'key'    => '_regular_price',
			'value'    => '', // dummy val so that all SKUs are valid and considered even if SKU is empty
			//'type' => 'CHAR',
			'compare' => '!=',
		);

		if ( version_compare( $wp_version, '3.2', '>=' ) ) { 
			$args = array(
				'post_type'			=> array( 'product' ),
				'post_status' 			=> 'publish',
				'ignore_sticky_posts'		=> 0,
				'orderby' 			=> $orderby,
				'order' 			=> $order,
				'posts_per_page' 		=> $per_page,
				'meta_query' 		=> array()
			);
			
			// Sorting by SKU? If so overwrite meta_query
			if ( '_sku' == $orderby ) { 
				$args['meta_query']['sku'] = $sku_query;
				$args['orderby'] = 'meta_value';
				$args['meta_query']['relation'] = 'AND';
			}
				
			if ( '_price' == $orderby ) { 
				$args['meta_query']['price'] = $price_query;
				$args['orderby'] = 'meta_value_num';
				$args['meta_query']['relation'] = 'AND';
			}

		} else { 
			$args = array(
				'post_type'			=> array( 'product'  ),
				'post_status' 			=> 'publish',
				'ignore_sticky_posts'		=> 0,
				'orderby' 			=> $orderby,
				'order' 			=> $order,
				'posts_per_page' 		=> $per_page,
				/*
				'meta_query' 			=> array(
					array(
						'key' 		=> '_visibility',
						'value' 	=> array( 'catalog', 'visible' ),
						'compare' 	=> 'IN'
					)
				)
				*/
			);
		}
		
		if ( empty( self::$settings['show_variations'] ) && 'yes' !== self::$settings['show_variations'] ) { 
				
			// Check wholesale pro suite Products Filters
			if ( !empty( $ign_wholesale_pro_suite ) && is_user_logged_in() ) { 
			
				$global_role_pricing_enabled = false; 
			
				 if ( is_user_logged_in() ) {
					$user = wp_get_current_user(); 
					$roles = ( array ) $user->roles; 
					foreach( $roles as $r ) { 
						if ( !empty( $ign_wholesale_pro_suite->settings['global_discounts'][ $r ] ) ) { 
							$global_role_pricing_enabled = true;
						}
					}
				 }

				// Wholesale roles 
				if ( !$global_role_pricing_enabled && 'yes' == $ign_wholesale_pro_suite->settings['tier_filter'] ) { 
				
					$ign_wholesale_pro_suite->get_roles();
					
					foreach( $ign_wholesale_pro_suite->roles as $role => $name ) {

						if ( !$current_user->has_cap( $role ) ) {
							continue;
						}
						
						$args['meta_query']['price'] = array(
							'key'    => '_' . $role . '_price',
							'value'    => '',
							'compare' => '!=',
						);
					}
				}
			}
			
			/* This breaks showing variable to regular shoppers when the form isn't set to show individual variations
			if ( !empty( $ign_wholesale_pro_suite ) ) { 
				// Retail filter 
				if ( 'yes' == $ign_wholesale_pro_suite->settings['retail_filter'] ) { 
				
					if ( !is_user_logged_in() ) { 
					
						$args['meta_query']['price'] = array(
							'key'    => '_regular_price',
							'value'    => '',
							'compare' => '!=',
							'type' => 'NUMERIC',
						);
						
					} else { 
					
						// check for a tier role, in which case retail filter does not apply 
						$ign_wholesale_pro_suite->get_roles();
						
						$has_tier_role = false; 
						
						foreach( $ign_wholesale_pro_suite->roles as $role => $name ) {

							// Not logged in with a tier role ? No filter applies, continue. 
							if ( !$current_user->has_cap( $role ) ) {
								continue;
							}
							
							$has_tier_role = true; 
						}
						
						if ( !$has_tier_role ) { 
						
							$args['meta_query']['price'] = array(
								'key'    => '_regular_price',
								'value'    => '',
								'compare' => '!=',
								'type' => 'NUMERIC',
								
							);
						}
					}
				}
			}
			*/
		}
		
		if ( !empty( self::$search_string ) ) {
			
			/*
			$args['s'] = self::$search_string;
			
			$args['meta_query']['sku'] = array(
				'key' => '_sku',
				'value' => self::$search_string,
				'compare' => 'LIKE',
			);
			//$args['orderby'] = 'meta_value';
			$args['meta_query']['relation'] = 'OR';
			*/
			
			
			$sql = 'select ID from ' . $wpdb->posts . ' left join ' . $wpdb->postmeta . ' on ID = post_id
				where post_title LIKE "%%%s%%" OR ( meta_key="_sku" and meta_value LIKE "%%%s%%" )';
				
			$sql = $wpdb->prepare( $sql, self::$search_string, self::$search_string );

			$ids = $wpdb->get_results( $sql, ARRAY_A );
			
			if ( !empty( $ids ) && !is_wp_error( $ids ) ) { 
				foreach( $ids as $id ) { 
					$product_restrictions[] = $id['ID']; 
				}
			}
		}

		// These would be product IDs from a 3rd party plugin such as Restricted Categories
		// that limit which products can be viewed/accessed
		if ( !empty( $product_restrictions ) ) { 
			$args['post__in'] = $product_restrictions;
			$product_restrictions = array_unique( $product_restrictions );
		}

		$args['post__in'] = array();
		
		if ( !empty( self::$settings['include_products'] ) ) { 
			if ( version_compare( WOOCOMMERCE_VERSION, '2.7', '>=' ) )
				$args['post__in'] = self::$settings['include_products'];
			else 
				$args['post__in'] = explode( ',', self::$settings['include_products'] );
		}
		
		// $product_restrictions, if set, contains a list of IDs that can be accessed 
		$args['post__in'] = array_unique( array_merge( $args['post__in'], $product_restrictions ) );
	
		if ( !empty( self::$settings['exclude_products'] ) ) { 
			if ( version_compare( WOOCOMMERCE_VERSION, '2.7', '>=' ) )
				$args['post__not_in'] = self::$settings['exclude_products'];
			else 
				$args['post__not_in'] = explode( ',', self::$settings['exclude_products'] );
		}
		
		$tax_query = array();
		
		if ( !empty( self::$settings['include_categories'] ) ) {

			$args['tax_query']['relation'] = 'AND';
			$tax_query[] = array(
					'taxonomy' => 'product_cat',
					'field'    => 'term_id',
					'terms'    => self::$settings['include_categories'],
					'operator' => 'IN',
			);
		}
		
		if ( !empty( self::$settings['exclude_categories'] ) ) {
			$args['tax_query']['relation'] = 'AND';
			$tax_query[] = array(
					'taxonomy' => 'product_cat',
					'field'    => 'term_id',
					'terms'    => self::$settings['exclude_categories'],
					'operator' => 'NOT IN',
			);
		}
		
		if ( !empty( $tax_query ) ) { 
			$args['tax_query'] = $tax_query;
			$args['tax_query']['relation'] = 'AND';
		}
//unset( $args['tax_query'][0]['terms'][0] );
//print_R( $args );
		/*
		If there is a taxo query AND post__in or post__not_in then unset those and do a second query
		*/

		$posts2 = array();
		
		if ( !empty( $args['post__in'] ) && !empty( $args['tax_query'] ) ) { 
			$args2 = $args; 
			//unset( $args2['tax_query'] );
			
			$products2 = new WP_Query( apply_filters( 'woocommerce_quick_order_products_query', $args2 ) );
		
			$posts2 = $products2->posts;
			unset( $args2['post__in'], $products2 );
		}
		
		//if ( !empty( $args['post__not_in'] ) && !empty( $args['tax_query'] ) ) { 
			
		//}

		// If there is a retail filter on, to filter products without an empty price 
		// then find all variation products and add their parents to the list of products
		$posts3 = array();
		$variations = array();
		
		if ( !empty( $args['meta_query']['price'] ) ) { 
			$args2 = $args; 
			unset( $args2['tax_query'] );
			$products2 = new WP_Query( apply_filters( 'woocommerce_quick_order_products_query', $args2 ) );
			$posts3 = $products2->posts;

			unset( $products2 );
			if ( !empty( $posts3 ) ) { 
				
				foreach( $posts3 as $k => $v ) { 
					$variations[] = $v->post_parent; 
				}
				
				$variations = array_unique( $variations );
				
				if ( !empty( $variations ) ) { 
					foreach( $variations as $k => $v ) { 
						$variations[ $k ] = new stdClass();
						@$variations[ $k ]->ID = $v;
					}
				}
				
				$posts2 = array_merge( $variations, $posts2 );
			}
		}

		if ( !empty( $current_page ) ) 
			$args['paged'] = $current_page;

		$products = new WP_Query( apply_filters( 'woocommerce_quick_order_products_query', $args ) );

		$posts = $products->posts; 
 
		// Find all posts in $posts2 that are not in $posts already. 
		// This routine removes any posts in $posts2 that are already in $posts.
		if ( isset( $posts2 ) && !empty( $posts2 ) ) { 
			
			$posts2 = array_udiff( $posts2, $posts, function ( $p1, $p2 ) { 
			
				if ( !isset( $p1->ID ) || !isset( $p2->ID ) ) { 
					return -1;
				}
			
				if ( $p1->ID < $p2->ID ) {
					return -1;
				} else if ( $p1->ID > $p2->ID ) {
					return 1;
				} else { 
					return 0;
				}
			});
		}
		
		if ( !empty( $posts2 )  ) { 
			$posts = array_merge( $posts, $posts2 );
			// Get SKU and Price for each products so that sorting can work 
			foreach( $posts as $k => $v ) { 
				$p = wc_get_product( $v->ID );
				if ( empty( $p ) ) { 
					continue;
				}
				if ( !empty( $p ) && method_exists( $p, 'get_price' ) ) { 
					$posts[ $k ]->price = $p->get_price();
					$posts[ $k ]->sku = $p->get_sku();
				} else { 
					$posts[ $k ]->price = $p->price;
					$posts[ $k ]->sku = $p->sku;
				}
			}
			unset( $p );
			self::$sort_orderby = $args['orderby'];
			
			if ( 'meta_value_num' == $args['orderby'] )
				self::$sort_orderby = 'price';
			else if ( 'meta_value' == $args['orderby'] )
				self::$sort_orderby = 'sku'; 
			else 
				self::$sort_orderby = $args['orderby'];
				
			self::$sort_order = $args['order'];
			usort( $posts, array( 'IGN_Wholesale_Pro_Quick_Orders', 'sort_objects' ) );
			$products->posts = $posts;
			$products->post_count = count( $products->posts );
		}
//@ini_set( 'display_errors', true );
//var_dump( $args ); die;
		/*
		if ( isset( $posts3 ) && !empty( $posts3 ) ) { 
			
			$posts3 = array_udiff( $posts3, $posts, function ( $p1, $p2 ) { 
			
				if ( !isset( $p1->ID ) || !isset( $p2->ID ) ) { 
					return -1;
				}
			
				if ( $p1->ID < $p2->ID ) {
					return -1;
				} else if ( $p1->ID > $p2->ID ) {
					return 1;
				} else { 
					return 0;
				}
			});
		}
				
		if ( !empty( $posts3 )  ) { 
			$posts = array_merge( $posts, $posts3 );
			// Get SKU and Price for each products so that sorting can work 
			foreach( $posts as $k => $v ) { 
				$p = wc_get_product( $v->ID );
				if ( method_exists( $p, 'get_price' ) ) { 
					$posts[ $k ]->price = $p->get_price();
					$posts[ $k ]->sku = $p->get_sku();
				} else { 
					$posts[ $k ]->price = $p->price;
					$posts[ $k ]->sku = $p->sku;
				}
			}
			unset( $p );
			self::$sort_orderby = $args['orderby'];
			
			if ( 'meta_value_num' == $args['orderby'] )
				self::$sort_orderby = 'price';
			else if ( 'meta_value' == $args['orderby'] )
				self::$sort_orderby = 'sku'; 
			else 
				self::$sort_orderby = $args['orderby'];
				
			self::$sort_order = $args['order'];
			usort( $posts, array( 'IGN_Wholesale_Pro_Quick_Orders', 'sort_objects' ) );
			$products->posts = $posts;
			$products->post_count = count( $products->posts );
		}
		*/

		$data = self::get_data( $products );

		// Remove any excluded products, do this in case there was an tax_query
		if ( !empty( $args['post__not_in'] ) ) { 
			
		}
		
		$out = json_encode( array( 'draw' => absint( $_POST['draw'] ), 'data' => $data, "recordsTotal" => count( $data ), 'recordsFiltered' => $products->found_posts ) );
		
		// UTF8 encoding error? Try converting the data to UTF8
		if ( false == $out && json_last_error() == JSON_ERROR_UTF8 ) { 
			$data = self::utf8ize( $data );
		}
		
		$out = json_encode( array( 'draw' => absint( $_POST['draw'] ), 'data' => $data, "recordsTotal" => count( $data ), 'recordsFiltered' => $products->found_posts ) );
		
		die( $out );
	}

	private static function utf8ize( $mixed ) {
	
		if ( is_array( $mixed ) ) {
			foreach ( $mixed as $key => $value ) {
				$mixed[$key] = self::utf8ize( $value );
			}
		} elseif ( is_string( $mixed ) ) {
			return mb_convert_encoding( $mixed, "UTF-8", "UTF-8" );
		}
		
		return $mixed;
	}

	private static function sort_objects($a, $b) {
		$sort_by = self::$sort_orderby;
		
		if ( $a->$sort_by == $b->$sort_by ) { 
			return 0; 
		}
		
		if ( 'asc' == strtolower( self::$sort_order ) ) { 
			return ( $a->$sort_by < $b->$sort_by ) ? -1 : 1;
		} else if ( 'desc' == strtolower( self::$sort_order ) ) { 
			return ( $a->$sort_by < $b->$sort_by ) ? 1 : -1;
		}
	}
	
	public static function get_data( $products ) { 
		global $post;
		
		$data = array();
		
		$fields = self::get_fields();
		
		if ( $products->have_posts() )
		while ( $products->have_posts() ) { 
		
			$products->the_post();

			$product = wc_get_product( $post->ID );

			if ( empty( $product ) || !method_exists( $product, 'is_type' ) ) { 
				continue;
			}
			
			$temp_data = array();
		
			// Filter expects and array of data to be returned.
			$temp_data = apply_filters( 'ignitewoo_quick_order_product_load', $temp_data, $product, $fields );
			
			if ( !empty( $temp_data ) && is_array( $temp_data ) ) { 
				$data[] = $temp_data;
				continue;
			}
			
			if ( ( $product->is_type( 'variable' ) || $product->is_type( 'variable-subscription' ) ) && ( !empty( self::$settings['show_variations'] ) && 'yes' == self::$settings['show_variations'] ) ) { 
			
				foreach ( $product->get_available_variations() as $product_data ) {
					
					$temp_data = array();
				
					// Add one empty element, this responsive "plus" icon colunm, hidden unless the screen is small enough to trigger 
					// responsive mode
					$temp_data[] = '';
					
					$variation_product = wc_get_product( $product_data['variation_id'] );
				
					if ( empty( $variation_product ) ) {
						continue;
					}
					
					// Check wholesale pro suite Products Filters
					if ( !empty( $ign_wholesale_pro_suite ) && is_user_logged_in() ) { 
					
						// Wholesale roles 
						if ( 'yes' == $ign_wholesale_pro_suite->settings['tier_filter'] ) { 
						
							$ign_wholesale_pro_suite->get_roles();
							
							foreach( $ign_wholesale_pro_suite->roles as $role => $name ) {

								if ( !$current_user->has_cap( $role ) ) {
									continue;
								}
								
								$p = get_post_meta( $variation_product->get_id(), '_' . $role . '_price', true );
								
								if ( '' == $p ) {
									continue 2; 
								}
							}
						}
					}
					
					if ( !empty( $ign_wholesale_pro_suite ) ) { 
						// Retail filter 
						if ( 'yes' == $ign_wholesale_pro_suite->settings['retail_filter'] ) { 
						
							if ( !is_user_logged_in() ) { 
							
								$p = $variation_product->get_price();
							
								if ( '' == $p || false == $p ) {
									continue; 
								}
								
							} else { 
							
								// check for a tier role, in which case retail filter does not apply 
								$ign_wholesale_pro_suite->get_roles();
								
								$has_tier_role = false; 
								
								foreach( $ign_wholesale_pro_suite->roles as $role => $name ) {

									// Not logged in with a tier role ? No filter applies, continue. 
									if ( !$current_user->has_cap( $role ) ) {
										continue;
									}
									
									$has_tier_role = true; 
								}
								
								if ( !$has_tier_role ) { 
								
									$p = $variation_product->get_price();
							
									if ( '' == $p || false == $p ) {
										continue; 
									}
								}
							}
						}
					}

					$product_data = self::list_product( $variation_product, $fields );

					unset( $variation_product );
					
					$temp_data = array_merge( $temp_data, $product_data );
				
					unset( $product_data );
					
					if ( !empty( $temp_data ) ) { 

						$data[] = $temp_data; // array_merge( array( 'DT_RowId' => $product->get_id() ), $temp_data );
					}
				}

			} else { 

				// Add one empty element, this responsive "plus" icon colunm, hidden unless the screen is small enough to trigger 
				// responsive mode
				$temp_data[] = '';
			
				$product_data = self::list_product( $product, $fields );
				
				$temp_data = array_merge( $temp_data, $product_data );
				
				unset( $product_data );
				
				if ( !empty( $temp_data ) ) { 

					$data[] = $temp_data; // array_merge( array( 'DT_RowId' => $product->get_id() ), $temp_data );
				}
			}
			
			
		}

		return $data;
		
	}
	
	public static function list_product( $product, $fields ) { 
		global $post; 
		
		$temp_data = array();

		foreach( $fields as $field ) { 

			if ( 'get_image_id' == $field['getter'] ) { 
					
					$size = array( 30, 30 );
					
					$display_value = get_the_post_thumbnail( $product->get_id(), $size );
						
					if ( empty( $display_value ) ) { 
						$img = wc_placeholder_img_src();
						$display_value = '<div class="product_image_wrap "><img src="' . $img . '"/></div>';	
						$temp_data[] = $display_value;
						continue; 
					}
					
					$image_title = esc_attr( get_the_title( get_post_thumbnail_id() ) );
					$image_link  = wp_get_attachment_url( get_post_thumbnail_id() );
					$image       = get_the_post_thumbnail( $product->get_id(), apply_filters( 'single_product_large_thumbnail_size', 'shop_thumbnail' ), array(
						'title' => $image_title
						) );

					if ( method_exists( $product, 'get_gallery_image_ids' ) )
						$attachment_count = count( $product->get_gallery_image_ids() );
					else
						$attachment_count = count( $product->get_gallery_attachment_ids() );

					/*
					if ( $attachment_count > 0 ) {
						$gallery = '[product-gallery]';
					} else {
						$gallery = '';
					}
					*/
					
					$gallery = '';
					
					$display_value = apply_filters( 'woocommerce_single_product_image_htmls', sprintf( '<a href="%s" itemprop="image" class="woocommerce-main-image " title="%s" data-rel="prettyPhoto' . $gallery . '">%s</a>', $image_link, $image_title, $image ), $product->get_id() );
					
					$display_value = '<div class="product_image_wrap ">' . $display_value . '</div>';
						
					$temp_data[] = $display_value;
					continue;
				
				
			} else if ( 'get_the_title' == $field['getter'] ) {
			
				$title = get_the_title( $post->ID );
				
				$title = apply_filters( 'ignitewoo_qof_product_title', $title, $post->ID );
				
				if ( !empty( self::$settings['link_title'] ) && 'yes' == self::$settings['link_title'] ) { 
					$link = get_permalink( $post->ID );
					$title = '<a href="' . $link . '" target="_blank">' . $title . '</a>';
				}
			
				$attrs = '';
				
				if ( ( $product->is_type( 'variation' ) || $product->is_type( 'variation-subscription' ) ) && ( !empty( self::$settings['show_variations'] ) && 'yes' == self::$settings['show_variations'] ) ) {
				
					ob_start();

					$attr_string = array();
					
					foreach ( $product->get_attributes() as $attr_key => $attr_val ) {

						$attr_name = ucwords( str_replace( array( 'attribute_', 'pa_' ), '', $attr_key ) );
						
						$attr_string[] = '<span class="qof_attr_name">' . $attr_name . '</span>: <span class="qof_attr_val">' . $product->get_attribute( $attr_key ) . '</span>';
					}
					
					?>
					<div class="variation_attributes">
						<?php echo implode( '<br/>', $attr_string ); ?>
					</div>
					
					<?php 
					$attrs = ob_get_clean();
				}
				
				$temp_data[] = $title . $attrs; 
				
				continue;
			
			} else if ( 'get_description' == $field['getter'] ) {
			
				$d = $product->get_description();
				
				if ( !empty( $d ) ) { 
					$d = substr( strip_tags( $d ), 0, 75 ) . '...';
				}
				
				// Allow plugins to filter the description if the want to
				$d = apply_filters( 'ignitewoo_quick_order_product_desc', $d, $product );
				
				$temp_data[] = $d;

				continue;
			
			} else if ( 'get_add_to_cart' == $field['getter'] ) {
			
				if ( ( $product->is_type( 'simple' ) || $product->is_type( 'subscription' ) ) && !empty( $product->get_price() ) ) {
					
					$d = '';
					
					if ( $product->is_in_stock() ) { 
						$d = '<form class="cart" method="post" enctype="multipart/form-data">';
					}
				
					ob_start();
					
					if ( function_exists( 'wc_get_stock_html' ) ) { 
						echo wc_get_stock_html( $product );
					}
					
					$gravity_form_data = get_post_meta( $product->get_id(), '_gravity_form_data', true ); 
					
					if ( !empty( $gravity_form_data['id'] ) ) {
					
						$d .= '<a href="' . $product->get_permalink() . '" class="btn btn-primary single_add_to_cart_button button alt" target="_blank">' . __( 'Choose Configuration','ignitewoo_wholesale_pro' ) . '</a>';
					
					} else { 
					
						if ( ! $product->is_sold_individually() && $product->is_in_stock() && $product->is_purchasable() ) {
							woocommerce_quantity_input( array(
								'input_value' => apply_filters( 'woocommerce_quantity_input_min', 1, $product ),
								'min_value' => apply_filters( 'woocommerce_quantity_input_min', 1, $product ),
								'max_value' => apply_filters( 'woocommerce_quantity_input_max', $product->backorders_allowed() ? '' : $product->get_stock_quantity(), $product )
							) );
						}
												
						$d .= ob_get_clean();

						$d .= '<input type="hidden" name="add-to-cart" value="' . esc_attr( $post->ID ) . '" />';
						
						// Get some default args, required by plugins that expect a 3rd param of args for the "woocommerce_loop_add_to_cart_link" filter
						$p_defaults = array(
							'quantity'   => 1,
							'class'      => implode( ' ', array_filter( array(
								'button',
								'product_type_' . $product->get_type(),
								$product->is_purchasable() && $product->is_in_stock() ? 'add_to_cart_button' : '',
								$product->supports( 'ajax_add_to_cart' ) && $product->is_purchasable() && $product->is_in_stock() ? 'ajax_add_to_cart' : '',
							) ) ),
							'attributes' => array(
								'data-product_id'  => $product->get_id(),
								'data-product_sku' => $product->get_sku(),
								'aria-label'       => '',
								'rel'              => 'nofollow',
							),
						);

						$the_args = apply_filters( 'woocommerce_loop_add_to_cart_args', $p_defaults, $product );

						if ( isset( $the_args['attributes']['aria-label'] ) ) {
							$the_args['attributes']['aria-label'] = strip_tags( $the_args['attributes']['aria-label'] );
						}
								
						ob_start(); 

						if ( $product->is_in_stock() ) { 
							echo apply_filters( 'woocommerce_loop_add_to_cart_link',
								sprintf( '<button href="%s" rel="nofollow" data-product_id="%s" data-product_sku="%s" class="button %s product_type_%s">%s</button>',
									esc_url( $product->add_to_cart_url() ),
									esc_attr( $post->ID ),
									esc_attr( $product->get_sku() ),
									$product->is_purchasable() && $product->is_in_stock() ? 'single_add_to_cart_button' : '',
									esc_attr( $product->get_type() ),
									esc_html( $product->add_to_cart_text() )
								),
							$product, $the_args );
						} else { 
							
							echo apply_filters( 'woocommerce_loop_add_to_cart_link',
								sprintf( '<a href="%s" rel="nofollow" data-product_id="%s" data-product_sku="%s" class="button %s product_type_%s" target="_blank">%s</a>',
									esc_url( $product->add_to_cart_url() ),
									esc_attr( $post->ID ),
									esc_attr( $product->get_sku() ),
									$product->is_purchasable() && $product->is_in_stock() ? 'single_add_to_cart_button' : '',
									esc_attr( $product->get_type() ),
									esc_html( $product->add_to_cart_text() )
								),
							$product, $the_args );
						}

						$d .= ob_get_clean();
						
						if ( $product->is_in_stock() ) { 
							$d .= '</form>';
						}
						
					}
			
				} else if ( ( $product->is_type( 'variation' ) || $product->is_type( 'subscription_variation' ) ) && ( !empty( self::$settings['show_variations'] ) && 'yes' == self::$settings['show_variations'] ) ) { 

					$d = '<form class="variations_form" method="post" enctype="multipart/form-data">';
					
					ob_start();
					
					if ( function_exists( 'wc_get_stock_html' ) ) { 
						echo wc_get_stock_html( $product );
					}
					
					$gravity_form_data = get_post_meta( $product->get_parent_id(), '_gravity_form_data', true ); 
					
					if ( !empty( $gravity_form_data['id'] ) ) {
					
						$d .= '<a href="' . $product->get_permalink() . '" class="btn btn-primary single_add_to_cart_button button alt" target="_blank">' . __( 'Choose Configuration','ignitewoo_wholesale_pro' ) . '</a>';
						
					} else { 
					
						$d .= '<input type="hidden" name="add-to-cart" value="' . esc_attr( $post->ID ) . '" />';
						$d .= '<input type="hidden" class="variation_id" name="variation_id" value="' . esc_attr( $product->get_id() ) . '" />';
						$d .= '<input type="hidden" class="single_variation" name="single_variation" value="1" />';
						
						if ( $product->is_in_stock() ) { 
							woocommerce_quantity_input( array(
								'min_value'   => apply_filters( 'woocommerce_quantity_input_min', $product->get_min_purchase_quantity(), $product ),
								'max_value'   => apply_filters( 'woocommerce_quantity_input_max', $product->get_max_purchase_quantity(), $product ),
								'input_value' => isset( $_POST['quantity'] ) ? wc_stock_amount( wp_unslash( $_POST['quantity'] ) ) : $product->get_min_purchase_quantity(), 
							) );
						}
						
						// Get some default args, required by plugins that expect a 3rd param of args for the "woocommerce_loop_add_to_cart_link" filter
						$p_defaults = array(
							'quantity'   => 1,
							'class'      => implode( ' ', array_filter( array(
								'button',
								'product_type_' . $product->get_type(),
								$product->is_purchasable() && $product->is_in_stock() ? 'add_to_cart_button' : '',
								$product->supports( 'ajax_add_to_cart' ) && $product->is_purchasable() && $product->is_in_stock() ? 'ajax_add_to_cart' : '',
							) ) ),
							'attributes' => array(
								'data-product_id'  => $product->get_id(),
								'data-product_sku' => $product->get_sku(),
								'aria-label'       => '',
								'rel'              => 'nofollow',
							),
						);

						$the_args = apply_filters( 'woocommerce_loop_add_to_cart_args', $p_defaults, $product );

						if ( isset( $the_args['attributes']['aria-label'] ) ) {
							$the_args['attributes']['aria-label'] = strip_tags( $the_args['attributes']['aria-label'] );
						}
						echo apply_filters( 'woocommerce_loop_add_to_cart_link',
							sprintf( '<button href="%s" rel="nofollow" data-product_id="%s" data-product_sku="%s" class="button %s product_type_%s">%s</button>',
								esc_url( $product->add_to_cart_url() ),
								esc_attr( $product->get_id() ),
								esc_attr( $product->get_sku() ),
								$product->is_purchasable() && $product->is_in_stock() ? 'single_add_to_cart_button' : '',
								esc_attr( $product->get_type() ),
								esc_html( $product->add_to_cart_text() )
							),
						$product, $the_args );
						
						$d .= ob_get_clean();
						
						$d .= '</form>';
					}
					
				} else if ( $product->is_type( 'variable' ) || $product->is_type( 'variable-subscription' ) ) { 
					
					$gravity_form_data = get_post_meta( $product->get_id(), '_gravity_form_data', true ); 
					
					if ( !empty( $gravity_form_data['id'] ) ) {
					
						$d .= '<a href="' . $product->get_permalink() . '" class="btn btn-primary single_add_to_cart_button button alt" target="_blank">' . __( 'Choose Configuration','ignitewoo_wholesale_pro' ) . '</a>';
						
					} else { 
						
						ob_start();
						
						woocommerce_variable_add_to_cart();
						
						do_action( 'woocommerce_after_add_to_cart_form' );
						
						$d = ob_get_clean();
					}
				
				/* Not working yet:
				} else if ( $product->is_type( 'bundle' ) ) {
				
					ob_start();
					
					wc_pb_template_add_to_cart();
					
					$d = ob_get_clean();
				*/
				} else { 
				
					$d = '<a href="' . get_permalink( $post->ID ) . '" class="button read_more_button" target="_blank">' . __( 'Read more', 'ignitewoo_wholesale_pro' ) . '</a>';
				
				}

				// Allow plugins to filter the add to cart form 
				$d = apply_filters( 'ignitewoo_quick_order_product_add_to_cart', $d, $product );
				
				$temp_data[] = $d;
				
				continue;
			
			} else if ( 'get_checkbox' == $field['getter'] ) {
		
				$temp_data[] = '<input type="checkbox" class="atc_product_ids" name="atc_product_ids[]" value="' . $post->ID . '">';
				continue;
			}
				
			if ( 'get_post_meta' == $field['getter'] ) {
				$temp_data[] = maybe_serialize( get_post_meta( $post->ID, $field['data'], true ) );
			} else if ( is_callable( array( $product, $field['getter'] ) ) ) {
				$temp_data[] = call_user_func_array( array( $product, $field['getter'] ), array() );
			} else if ( is_callable( $field['getter'] ) ) { 
				$temp_data[] = call_user_func( $field['getter'], $product->get_id() );
			}
			
		}
		
		return $temp_data; 
	}
	
	public static function check_non_ajax_add_to_cart() { 

		if ( empty( $_POST['ign_qof_ajax_disabled'] ) )
			return;
		
		if ( empty( $_POST['action'] ) || 'ign_multi_add_to_cart' !== $_POST['action'] )
			return;
	
		if ( empty( $_POST['items'] ) ) 
			return;
			
		$_POST['items'] = json_decode( stripcslashes( $_POST['items'] ), true );

		self::multi_add_to_cart( false );
	}

	public static function multi_add_to_cart( $exit = true ) { 

		if ( empty( $_POST['items'] ) )
			die;
		
		$success = array(); 
		$errors = array();
		
		foreach( $_POST['items'] as $item ) { 

			if ( empty( $item['product_id'] ) || absint( $item['product_id'] ) <= 0 )
				continue;
			
			// Variable product 
			if ( !empty( $item['attrs'] ) ) { 
				$res = self::add_to_cart_variable( $item, false );
			} else { 
				$res = self::add_to_cart( $item, false );
			}
			
			$title = get_the_title( $item['product_id'] );
			
			if ( true === $res ) {
				$success[] = '<div class="atc_success">' . sprintf( __( '%s added to the cart', 'ignitewoo_wholesale_pro' ), $title ) . '</div>';
			} else { 
				$errors[] = '<div class="atc_errors">' . sprintf( __( '%s not added to the cart', 'ignitewoo_wholesale_pro' ), $title ) . '</div>';
			}
		}

		// If Ajax Add to Cart is disabled via this form's settings add any necessary success/error messages and return
		if ( false === $exit ) { 
			if ( !empty( $errors ) ) { 
				foreach( $errors as $err ) {
					wc_add_notice( $err, 'error' );
				}
			}
			if ( !empty( $success ) ) { 
				foreach( $success as $s ) {
					wc_add_notice( $s );
				}
			}
			return;
		}
		
		// Ajax is taking place (we didn't return from this function) so reload any errors directly from WC
		$errors = wc_get_notices( 'error' );
		
		// Clear all notices
		wc_clear_notices();
		
		// Customize the message with a div wrapper and product title, note that any ".wc-foward" buttons in the message
		// will be hidden by our CSS since they are not necessary for our use case.
		if ( !empty( $errors ) ) { 
			foreach( $errors as $k => $e ) { 
				if ( is_array( $e ) ) { 
					$e = implode( ' ' , $e );
				}
				$errors[ $k ] = '<div class="atc_errors">' . $title . ': ' . $e . '</div>';
			}
		}
	
		self::get_refreshed_fragments( $success, $errors );
		
		die;
	}
	
	public static function add_to_cart( $item = false, $exit = true ) {
	
		ob_start();

		if ( empty( $item ) ) { 
			
			$product_id        = apply_filters( 'woocommerce_add_to_cart_product_id', absint( $_POST['product_id'] ) );
			$quantity          = empty( $_POST['quantity'] ) ? 1 : wc_stock_amount( $_POST['quantity'] );
			
		} else { 
		
			$product_id        = apply_filters( 'woocommerce_add_to_cart_product_id', absint( $item['product_id'] ) );
			$quantity          = empty( $item['quantity'] ) ? 1 : wc_stock_amount( $item['quantity'] );
		}

		$passed_validation = apply_filters( 'woocommerce_add_to_cart_validation', true, $product_id, $quantity );
		$product_status    = get_post_status( $product_id );

		if ( $passed_validation && false !== WC()->cart->add_to_cart( $product_id, $quantity ) && 'publish' === $product_status ) {

			do_action( 'woocommerce_ajax_added_to_cart', $product_id );

			//if ( 'yes' === get_option( 'woocommerce_cart_redirect_after_add' )  ) {
			//	wc_add_to_cart_message( array( $product_id => $quantity ), true );
			//}

			if ( $exit ) { 
				// Return fragments
				self::get_refreshed_fragments();
				
			} else { 
			
				ob_end_clean();
				return true;
			}

		} else {

			if ( $exit ) { 
				$errors = wc_get_notices( 'error' );
				wc_clear_notices();
			
				// If there was an error adding to the cart, redirect to the product page to show any errors
				$data = array(
					'error'       => true,
					'product_url' => apply_filters( 'woocommerce_cart_redirect_after_error', get_permalink( $product_id ), $product_id ),
					'error_message' => '<div class="atc_errors">' . $errors[0] . '</div>'
				);

				wp_send_json( $data );
				
			} else { 
			
				ob_end_clean();
				return false;
			}
		}
	}
	
	public static function add_to_cart_variable( $item = false, $exit = true ) {
	
		if ( empty( $item ) ) { 
			$args = isset( $_POST['args'] ) ? $_POST['args'] : array();
			
			if ( empty( $args ) ) {
			
				self::json_headers();

				// If there was an error adding to the cart, redirect to the product page to show any errors
				$data = array(
					'error' => true,
				);

				echo json_encode( $data );
			}
		
			$args = wp_parse_args( $args );
			
			if ( empty( $args ) ) {
			
				self::json_headers();

				// If there was an error adding to the cart, redirect to the product page to show any errors
				$data = array(
					'error' => true,
				);

				echo json_encode( $data );
			}

			if ( !empty( $args['add-to-cart'] ) && empty( $args['product_id'] ) ) { 
				$args['product_id'] = $args['add-to-cart'];
			}
			
			$variations = array();
			
			foreach( $args as $key => $val ) { 
				if ( false === strpos( $key, 'attribute_' ) )
					continue;
					
				$variations[ $key ] = $val; 
			}

		} else { 
		
			$args = $item;
			
			$args = wp_parse_args( $args );			
						
			$variations = array();
			
			foreach( $args['attrs'] as $key => $val ) { 
				if ( false === strpos( $val['name'], 'attribute_' ) )
					continue;
					
				$variations[ $val['name'] ] = $val['val']; 
			}
		}

		$product_id = $args['product_id'];
		$variation_id = $args['variation_id'];
		$quantity = empty( $args['quantity'] ) ? 1 : $args['quantity'];
		
		$cart_item_data = null;

		$passed_validation = apply_filters( 'woocommerce_add_to_cart_validation', true, $product_id, $quantity, $variation_id, $variations, $cart_item_data );

		if ( $passed_validation && WC()->cart->add_to_cart( $product_id, $quantity, $variation_id, $variations ) ) {

			do_action( 'woocommerce_ajax_added_to_cart', $product_id );

			//if ( get_option( 'woocommerce_cart_redirect_after_add' ) == 'yes' ) {
			//	wc_add_to_cart_message( $product_id );
			//}

			if ( $exit ) { 
				self::get_refreshed_fragments();
			} else { 
				return true; 
			}

		} else {

			if ( $exit ) { 
				
				$errors = wc_get_notices( 'error' );
				wc_clear_notices();
			
				// If there was an error adding to the cart, redirect to the product page to show any errors
				$data = array(
					'error'       => true,
					'product_url' => apply_filters( 'woocommerce_cart_redirect_after_error', get_permalink( $product_id ), $product_id ),
					'error_message' => '<div class="atc_errors">' . $errors[0] . '</div>'
				);

				self::json_headers();
				echo json_encode( $data );
				
			} else { 
				return false;
			}
		}

		die();
	}

	private static function json_headers() {
		header( 'Content-Type: application/json; charset=utf-8' );
	}
	
	public static function get_refreshed_fragments( $success = array(), $errors = array() ) {

		self::json_headers();

		ob_start();

		woocommerce_mini_cart();

		$mini_cart = ob_get_clean();

		// Fragments and mini cart are returned
		$data = array(
			'fragments' => apply_filters( 'add_to_cart_fragments', array(
					'div.widget_shopping_cart_content' => '<div class="widget_shopping_cart_content">' . $mini_cart . '</div>'
				)
			),
			'cart_hash' => WC()->cart->get_cart() ? md5( json_encode( WC()->cart->get_cart() ) ) : '',
			'success' => !empty( $success ) ? implode( '', $success ) : false,
			'errors' => !empty( $errors ) ? implode( '', $errors ): false,
		);

		die( json_encode( $data ) );
	}
	
	// Backend settings product search
	public static function json_search_products( $x = '', $post_types = array( 'product' ) ) {
		global $wpdb;

		ob_start();

		check_ajax_referer( 'search-products', 'security' );

		$term = (string) wc_clean( stripslashes( $_GET['term'] ) );

		if ( empty( $term ) ) {
			die();
		}

		$like_term = '%' . $wpdb->esc_like( $term ) . '%';

		if ( is_numeric( $term ) ) {
			$query = $wpdb->prepare( "
				SELECT ID FROM {$wpdb->posts} posts LEFT JOIN {$wpdb->postmeta} postmeta ON posts.ID = postmeta.post_id
				WHERE posts.post_status = 'publish'
				AND (
					posts.post_parent = %s
					OR posts.ID = %s
					OR posts.post_title LIKE %s
					OR (
						postmeta.meta_key = '_sku' AND postmeta.meta_value LIKE %s
					)
				)
			", $term, $term, $term, $like_term );
		} else {
			$query = $wpdb->prepare( "
				SELECT ID FROM {$wpdb->posts} posts LEFT JOIN {$wpdb->postmeta} postmeta ON posts.ID = postmeta.post_id
				WHERE posts.post_status = 'publish'
				AND (
					posts.post_title LIKE %s
					or posts.post_content LIKE %s
					OR (
						postmeta.meta_key = '_sku' AND postmeta.meta_value LIKE %s
					)
				)
			", $like_term, $like_term, $like_term );
		}

		$query .= " AND posts.post_type IN ('" . implode( "','", array_map( 'esc_sql', $post_types ) ) . "')";

		if ( ! empty( $_GET['exclude'] ) ) {
			$query .= " AND posts.ID NOT IN (" . implode( ',', array_map( 'intval', explode( ',', $_GET['exclude'] ) ) ) . ")";
		}

		if ( ! empty( $_GET['include'] ) ) {
			$query .= " AND posts.ID IN (" . implode( ',', array_map( 'intval', explode( ',', $_GET['include'] ) ) ) . ")";
		}

		if ( ! empty( $_GET['limit'] ) ) {
			$query .= " LIMIT " . intval( $_GET['limit'] );
		}

		$posts          = array_unique( $wpdb->get_col( $query ) );
		$found_products = array();

		if ( ! empty( $posts ) ) {
			foreach ( $posts as $post ) {
				$product = wc_get_product( $post );

				if ( ! current_user_can( 'read_product', $post ) ) {
					continue;
				}

				if ( ! $product || ( $product->is_type( 'variation' ) && empty( $product->parent ) ) ) {
					continue;
				}
				
				// Skip variations, but not the parents of variations
				if ( ! $product || ( $product->is_type( 'variation' ) ) ) {
					continue;
				}

				$found_products[ $post ] = rawurldecode( $product->get_formatted_name() );
			}
		}

		$found_products = apply_filters( 'woocommerce_json_search_found_products', $found_products );

		wp_send_json( $found_products );
	}
	
	public static function register_post_type() { 

		register_post_type( 'quick_order_forms',
			apply_filters( 'woocommerce_register_post_type_product',
				array(
					'labels'              => array(
							'name'                  => __( 'Quick Order Forms', 'ignitewoo_wholesale_pro' ),
							'singular_name'         => __( 'Quick Order Form', 'ignitewoo_wholesale_pro' ),
							'menu_name'             => _x( 'Quick Order Forms', 'Admin menu name', 'ignitewoo_wholesale_pro' ),
							'add_new'               => __( 'Add Quick Order Form', 'ignitewoo_wholesale_pro' ),
							'add_new_item'          => __( 'Add New Quick Order Form', 'ignitewoo_wholesale_pro' ),
							'edit'                  => __( 'Edit', 'ignitewoo_wholesale_pro' ),
							'edit_item'             => __( 'Edit Quick Order Form', 'ignitewoo_wholesale_pro' ),
							'new_item'              => __( 'New Quick Order Form', 'ignitewoo_wholesale_pro' ),
							'view'                  => __( 'View Quick Order Form', 'ignitewoo_wholesale_pro' ),
							'view_item'             => __( 'View Quick Order Form', 'ignitewoo_wholesale_pro' ),
							'search_items'          => __( 'Search Quick Order Forms', 'ignitewoo_wholesale_pro' ),
							'not_found'             => __( 'No Quick Order Forms found', 'ignitewoo_wholesale_pro' ),
							'not_found_in_trash'    => __( 'No Quick Order Forms found in trash', 'ignitewoo_wholesale_pro' ),
							'parent'                => __( 'Parent Quick Order Form', 'ignitewoo_wholesale_pro' ),
						),
					'description'         => __( 'This is where you can add new quick order forms to your store.', 'ignitewoo_wholesale_pro' ),
					'public'              => false,
					'show_ui'             => true,
					'capability_type'     => 'product',
					'show_in_menu'		=> 'woocommerce',
					'map_meta_cap'        => true,
					'publicly_queryable'  => false,
					'exclude_from_search' => true,
					'hierarchical'        => false, // Hierarchical causes memory issues - WP loads all records!
					'rewrite'             => false,
					'query_var'           => false,
					'supports'            => array( 'title' ),
					'has_archive'         => false,
					'show_in_nav_menus'   => false,
				)
			)
		);
	}
	
	public static function screen_ids( $screen_ids = null ) { 
		$screen_ids[] = 'quick_order_forms';
		return $screen_ids; 
	}
	
	public static function add_meta_boxes() { 
		add_meta_box( 
			'qof-box',
			__( 'Settings', 'ignitewoo_wholesale_pro' ),
			__CLASS__ . '::render_meta_box',
			'quick_order_forms',
			'normal',
			'default'
		);
		add_meta_box( 
			'qof-shortcode-box',
			__( 'Shortcode', 'ignitewoo_wholesale_pro' ),
			__CLASS__ . '::render_shortcode_box',
			'quick_order_forms',
			'side',
			'high'
		);
	}
	
	public static function render_meta_box() { 
		global $post;
		$box = new IGN_Wholesale_Pro_Quick_Order_Settings();
		$settings = get_post_meta( $post->ID, 'quick_order_settings', true );
		$box->settings = $settings;
		$box->admin_options();
	}
	
	public static function render_shortcode_box() { 
		global $post;
		?>
		<p><?php _e( 'Use the following shortcode to inject this form into a post or page', 'ignitewoo_wholesale_pro' ); ?>:</p>
		<code>[wsp_quick_order_form id="<?php echo $post->ID ?>"]</code>
		<p><?php _e( 'Or use the following PHP code to inject this form', 'ignitewoo_wholesale_pro' ); ?>:</p>
		<code>&lt;?php wsp_quick_order_form( <?php echo $post->ID ?> )?&gt;</code>
		<?php
	}
	
	public static function save_post( $post_id ) { 

		if ( defined( 'DOING_AUTOSAVE' ) && DOING_AUTOSAVE ) 
			return;

		if ( defined( 'DOING_AJAX' ) && DOING_AJAX ) 
			return;
			
		if ( ! current_user_can( 'edit_post', $post_id ) )
			return;
			
		if ( false !== wp_is_post_revision( $post_id ) )
			return;
			
		$settings = array();

		foreach( $_POST as $key => $val ) {
		
			if ( 'woocommerce_ignitewoo_quick_orders_' !== substr( $key, 0, 35 ) )
				continue;
				
			$key = str_replace( 'woocommerce_ignitewoo_quick_orders_', '', $key );
		
			if ( ( 'show_price' == $key || 'show_sku' == $key || 'show_desc' == $key || 'link_title' == $key || 'disable_ajax_atc' == $key || 'multi_add' == $key || 'show_image' == $key || 'disable_paging' == $key || 'disable_search' == $key || 'show_hidden' == $key || 'show_variations' == $key ) && 1 == $val ) {
				$val = 'yes';
			} else if ( ( 'show_sku' == $key || 'show_image' == $key || 'disable_paging' == $key || 'disable_search' == $key || 'show_hidden' == $key || 'show_variations' == $key ) && 1 != $val ) { 
				$val = 'no';
			}
			
			$settings[ $key ] = $val;
		}

		if ( isset( $_POST['show_hidden'] ) )
			self::$settings['show_hidden'] = $_POST['show_hidden'];
		else 
			self::$settings['show_hidden'] = 'no';

		update_post_meta( $post_id, 'quick_order_settings', $settings );
	}
	
}
global $quick_orders; 
$quick_orders = new IGN_Wholesale_Pro_Quick_Orders();

function wsp_quick_order_form( $id = null ) { 
	if ( empty( $id ) )
		return;
	do_shortcode( '[wsp_quick_order_form id="' . $id . '"]' );

}

