<?php 



if ( ! defined( 'ABSPATH' ) ) exit;



include_once ( WP_PLUGIN_DIR . '/woocommerce/includes/admin/reports/class-wc-report-customer-list.php' );



class WC_Report_WCWS_Sales_By_Customer extends WC_Report_Customer_List {



	private $ws_roles = array();



	public function __construct() {

		global $wp_roles;

		

		parent::__construct();



		foreach( $wp_roles->roles as $role => $vals ) { 

			if ( 'ignite_level' !== substr( $role, 0, 12 ) ) { 

				continue;

			}

			

			$this->ws_roles[] = $role;

		}

	}



	public function prepare_items() {

		global $wpdb;



		$current_page = absint( $this->get_pagenum() );

		

		$per_page     = 20;



		// Init column headers

		$this->_column_headers = array( $this->get_columns(), array(), $this->get_sortable_columns() );



		add_action( 'pre_user_query', array( $this, 'order_by_last_name' ) );



		// Get wholesale users ids

		$wholesale_query = "SELECT $wpdb->users.ID

			FROM $wpdb->users

			INNER JOIN $wpdb->usermeta

			ON $wpdb->users.ID = $wpdb->usermeta.user_id

			WHERE $wpdb->usermeta.meta_key = '" . $wpdb->prefix . "capabilities'

			AND (";

	

		$counter = 1;

		

		foreach ( $this->ws_roles as $role_key ) {



			$wholesale_query .= " $wpdb->usermeta.meta_value LIKE '%$role_key%' ";



			if ( $counter < count( $this->ws_roles ) ) {

				$wholesale_query .= " OR ";

			}



			$counter++;

		}



		$wholesale_query .= ")";



		$query_result = $wpdb->get_results( $wholesale_query , ARRAY_A );

		$wholesale_user_ids = array();



		foreach ( $query_result as $result ) { 

			$wholesale_user_ids[] = $result[ 'ID' ];

		}

		

		// We need this for pagination

		$query = new WP_User_Query( array(

			'include' => $wholesale_user_ids,

			'number'  => $per_page,

			'offset'  => ( $current_page - 1 ) * $per_page

		) );



		$this->items = $query->get_results();



		remove_action( 'pre_user_query', array( $this, 'order_by_last_name' ) );



		// Pagination

		$this->set_pagination_args( array(

			'total_items' => $query->total_users,

			'per_page'    => $per_page,

			'total_pages' => ceil( $query->total_users / $per_page )

		) );

	}

}

