<?php 



if ( ! defined( 'ABSPATH' ) ) exit;



include_once ( WP_PLUGIN_DIR . '/woocommerce/includes/admin/reports/class-wc-report-sales-by-product.php' );



class WC_Report_WCWS_Sales_By_Product extends WC_Report_Sales_By_Product {



	private $ws_roles = array();



	public function __construct() {

		global $wp_roles;

		

		// Parent class has a constructor

		parent::__construct();

		

		$roles = array();

		

		//parent::__construct();



		foreach( $wp_roles->roles as $role => $vals ) { 

			if ( 'ignite_level' !== substr( $role, 0, 12 ) ) { 

				continue;

			}

			

			$roles[] = $role;

		}

		

		$users = get_users( array( 'role__in' => $roles ) );

		

		if ( empty( $users ) ) {

			return;

		}

		

		foreach( $users as $user ) { 

			$this->user_ids[] = $user->data->ID;

		}



	}

	

	/**

	* Filter the report query to only retrieve orders by wholesale users

	* 

	*/

	public function filter_report_query( $query ) {

		global $wpdb;

		

		if ( empty( $this->user_ids ) ) { 

			return $query;

		}



		$user_ids = implode( '","', $this->user_ids );

		

		// ! Very Important ! this must be posts.ID not $wpdb->posts.ID or else it will error out

		$wwpp_where_query = " AND posts.ID IN (

			SELECT $wpdb->postmeta.post_id FROM $wpdb->postmeta

			WHERE $wpdb->postmeta.meta_key = '_customer_user' and $wpdb->postmeta.meta_value in (\"" . $user_ids . "\")

		)";



		$query[ 'where' ] .= $wwpp_where_query;



		return $query;



	}



	public function output_report() {



		add_filter( 'woocommerce_reports_get_order_report_query' , array( $this , 'filter_report_query' ) , 10 , 1 );



		parent::output_report();



		remove_filter( 'woocommerce_reports_get_order_report_query' , array( $this , 'filter_report_query' ) , 10 );



	}

}



