<?php 



if ( ! defined( 'ABSPATH' ) ) exit;



class WCWS_Report {



	public function __construct( ) {

		add_filter( 'woocommerce_admin_reports' , array( $this , 'reports' ), 90, 1 );

		add_filter( 'wc_admin_reports_path'     , array( $this , 'admin_reports' ) , 90 , 3 );

	}



	public static function instance( ) {



		if ( !self::$_instance instanceof self )

			self::$_instance = new self( );



		return self::$_instance;



	}



	public function reports( $reports ) {



		$report_sections = array(

			'wcws_sales_by_date' => array(

				'title'       => __( 'Sales by date' , 'ignitewoo_wholesale_pro' ),

				'description' => '',

				'hide_title'  => true,

				'callback'    => array( 'WC_Admin_Reports' , 'get_report' )

			),

			'wcws_sales_by_customer' => array(

				'title'       => __( 'Sales by wholesale customers' , 'ignitewoo_wholesale_pro' ),

				'description' => '',

				'hide_title'  => true,

				'callback'    => array( 'WC_Admin_Reports' , 'get_report' )

			),

			'wcws_sales_by_product' => array(

				'title'       => __( 'Sales by product' , 'ignitewoo_wholesale_pro' ),

				'description' => '',

				'hide_title'  => true,

				'callback'    => array( 'WC_Admin_Reports' , 'get_report' )

			)

		);



		$report_sections = apply_filters( 'wcws_report_sections' , $report_sections );



		$reports[ 'wcws_reports' ] = array(

			'title'   => __( 'Wholesale' , 'ignitewoo_wholesale_pro' ),

			'reports' => $report_sections

		);



		return $reports;



	}



	public function admin_reports( $file_path , $name , $class ) {



		switch ( $name ) {



			case 'wcws-sales-by-date':

				return dirname( __FILE__ ) . '/class-wc-report-wcws-sales-by-date.php';

				break;

			case 'wcws-sales-by-customer':

				return dirname( __FILE__ ) . '/class-wc-report-wcws-sales-by-customer.php';

				break;

			case 'wcws-sales-by-product':

				return dirname( __FILE__ ) . '/class-wc-report-wcws-sales-by-product.php';

				break;

		}



		return $file_path;



	}

}



new WCWS_Report();

