<?php 
/*
 * Copyright (c) 2016 - IgniteWoo.com - ALL RIGHTS RESERVED
 */

// Main table that displays products. 
// WARNING: Do not alter CSS class and ID names. 

global $products, $quick_order_settings, $post;

?>



<div class="woocommerce columns-1">

<?php if ( $products->have_posts() ) { ?>

	<?php 
		if ( empty( $quick_order_settings['disable_paging'] ) || 'no' == $quick_order_search['disable_paging'] )
			include( dirname( __FILE__ ) . '/page-navigation.php' ) 
	?>

	<table class="shop_table">
		<thead>
			<tr>
				<th class="product_title"><?php _e( 'Product', 'ignitewoo_wholesale_pro' ) ?></th>
				
				<?php if ( !empty( $quick_order_settings['show_sku'] ) && 'yes' == $quick_order_settings['show_sku'] ) { ?>
				<th class="product_sku"><?php _e( 'SKU', 'ignitewoo_wholesale_pro' ) ?></th>
				<?php } ?>
				
				<th><?php _e( 'Price', 'ignitewoo_wholesale_pro' ) ?></th>
				<th class="action" style="text-align:center"><?php _e( 'Action', 'ignitewoo_wholesale_pro' ) ?></th>
			</tr>
		</thead>
		<tbody>
		<?php 
	
		while ( $products->have_posts() ) {

			$products->the_post(); 
			
			$product = get_product( $post->ID ); 

			if ( !is_object( $product ) ) { 
				continue;
			}

			if ( !$product->is_visible() )
				continue;
				
			if ( !$product->is_type( 'simple' ) && !$product->is_type( 'variable' ) )
				continue;
				
			// Disallow products without a price, free products have a price of zero (0) and those are Ok
			if ( '' == $product->get_price() )
				continue;

		?>
		<tr class="product_row">
			<td class="product_info">
				<?php 
				
				
				
				if ( !empty( $quick_order_settings['show_image'] ) && 'yes' == $quick_order_settings['show_image'] ) {
					if ( has_post_thumbnail() ) {

						$image_title = esc_attr( get_the_title( get_post_thumbnail_id() ) );
						$image_link  = wp_get_attachment_url( get_post_thumbnail_id() );
						$image       = get_the_post_thumbnail( $post->ID, apply_filters( 'single_product_large_thumbnail_size', 'shop_thumbnail' ), array(
							'title' => $image_title
							) );

						$attachment_count = count( $product->get_gallery_attachment_ids() );

						if ( $attachment_count > 0 ) {
							$gallery = '[product-gallery]';
						} else {
							$gallery = '';
						}

						echo apply_filters( 'woocommerce_single_product_image_html', sprintf( '<a href="%s" itemprop="image" class="woocommerce-main-image" title="%s" data-rel="prettyPhoto' . $gallery . '">%s</a>', $image_link, $image_title, $image ), $post->ID );

					} else {

						echo apply_filters( 'woocommerce_single_product_image_html', sprintf( '<img class="attachment-shop_thumbnail" src="%s" alt="Placeholder" />', wc_placeholder_img_src() ), $post->ID );

					}
				}
			if ( 'yes' === $quick_order_settings['link_title'] ) { 
			?>
				<div class="the_title">
					<a href="<?php echo get_the_permalink( $post->ID ) ?>" target="_blank"><?php the_title()?></a>
				</div>
			<?php 
			} else { 
			?>
				<div class="the_title"><?php the_title()?></div>
			<?php } ?>
			
			</td>
			
			<?php if ( !empty( $quick_order_settings['show_sku'] ) && 'yes' == $quick_order_settings['show_sku'] ) { ?>
			<td class="product_sku"><?php echo $product->get_sku() ?></td>
			<?php } ?>
			
			<td class="quick_order_price"><?php echo $product->get_price_html() ?></td>
			
			<td class="quick_order_mini_form">
				<?php if ( $product->is_type( 'simple' ) ) { ?>
			
					<form class="cart" method="post" enctype='multipart/form-data'>

					<?php
						if ( ! $product->is_sold_individually() )
							woocommerce_quantity_input( array(
								'min_value' => apply_filters( 'woocommerce_quantity_input_min', 1, $product ),
								'max_value' => apply_filters( 'woocommerce_quantity_input_max', $product->backorders_allowed() ? '' : $product->get_stock_quantity(), $product )
							) );
					?>

					<input type="hidden" name="add-to-cart" value="<?php echo esc_attr( $product->id ); ?>" />

					<?php			
						$args = array(
							'quantity'   => 1,
							'class'      => implode( ' ', array_filter( array(
								'button',
								'product_type_' . $product->get_type(),
								$product->is_purchasable() && $product->is_in_stock() ? 'add_to_cart_button' : '',
								$product->supports( 'ajax_add_to_cart' ) && $product->is_purchasable() && $product->is_in_stock() ? 'ajax_add_to_cart' : '',
							) ) ),
							'attributes' => array(
								'data-product_id'  => $product->get_id(),
								'data-product_sku' => $product->get_sku(),
								'aria-label'       => '',
								'rel'              => 'nofollow',
							),
						);
					
						echo apply_filters( 'woocommerce_loop_add_to_cart_link',
							sprintf( '<button href="%s" rel="nofollow" data-product_id="%s" data-product_sku="%s" class="button %s product_type_%s">%s</button>',
								esc_url( $product->add_to_cart_url() ),
								esc_attr( $product->id ),
								esc_attr( $product->get_sku() ),
								$product->is_purchasable() && $product->is_in_stock() ? 'single_add_to_cart_button' : '',
								esc_attr( $product->product_type ),
								esc_html( $product->add_to_cart_text() )
							),
						$product, $args );
					?>
					</form>
					
				<?php 
					
				} else { 
					
					wp_enqueue_script( 'ign-add-to-cart-variation' );
					woocommerce_variable_add_to_cart();
				}
				?>
			</td>
		</tr>
		<?php 
		} // end of the loop. ?>
		</tbody>
	</table>
	<?php include( dirname( __FILE__ ) . '/page-navigation.php' ) ?>
<?php }

wp_reset_postdata();
?>
</div>
