<?php
/**
  * Copyright (c) 2018 - IgniteWoo.com - ALL RIGHTS RESERVED
  *
  * Main template file, as of plugin version 3.0
  *
  * WARNING: Do not alter CSS class and ID names, do not remove any DIVs, and do not alter the $table_id variable.
  * If you do then the software could break.
  *
  */
 
/**
  * NOTE: The table is dynamically loaded via Javascript. 
  *
  * Filters are available to modify some aspects of product data display using your own custom PHP code: 
  *	"ignitewoo_quick_order_product_load" - load all data for the product 
  *	"ignitewoo_quick_order_product_desc" - description snippet filter
  *	"ignitewoo_quick_order_product_add_to_cart" - add to cart form filter
  *
  * See the plugin's code for filter use, review the get_data() function within the code.
  * Note that IgniteWoo does not provide support for customizations.
  *
  * If you would like to have compatability for specific plugins contact us with the details.
  *
  */


global $products, $post, $max_number_pages;

remove_all_actions( 'woocommerce_before_add_to_cart_form' );
remove_all_actions( 'woocommerce_after_add_to_cart_form' );
remove_all_actions( 'woocommerce_before_add_to_cart_button' );
remove_all_actions( 'woocommerce_after_add_to_cart_button' );

$table_id = 'ign_qof_table_' . IGN_Wholesale_Pro_Quick_Orders::$form_id;
?>
<div class="woocommerce quick_order_form_outer">
		
	<?php if ( function_exists( 'wc_print_notices' ) ) wc_print_notices(); ?>

	<?php
	if ( empty( IGN_Wholesale_Pro_Quick_Orders::$settings['disable_search'] ) || 'yes' !== IGN_Wholesale_Pro_Quick_Orders::$settings['disable_search'] )
		include( dirname( __FILE__ ) . '/search-form.php' );
	?>
	
	<div class="ignitewoo_quick_order_form_wrap">
		<table id="<?php echo $table_id ?>" class="wc-product-table woocommerce">
			<thead>
				<tr>
					<th class="select-checkbox"></th>
					<?php foreach( IGN_Wholesale_Pro_Quick_Orders::get_fields() as $field ) { ?>
					<th><?php echo $field['name'] ?></th>
					<?php } ?>
				</tr>
			</thead>
		</table>
		
		<?php if ( !empty( IGN_Wholesale_Pro_Quick_Orders::$settings['multi_add'] ) && 'yes' == IGN_Wholesale_Pro_Quick_Orders::$settings['multi_add'] ) { ?>
			<button class="multi_atc button btn" style="float:right;margin-top: 1em"><?php _e( 'Add selected to cart', 'ignitewoo_wholesale_pro' ) ?></button>
			<div class="atc_message"></div>
		<?php } ?>
	</div>
</div>
